<?xml version="1.0" encoding="UTF-8"?>
<TestCase name="List_Distinct_Operations" version="5">

<meta>
   <create author="rbrown" buildNumber="7.1.0.611" date="01/15/2014" host="Ricks-MacBook-Pro.local" version="7.1"/>
   <lastEdited author="admin" buildNumber="9.5.1.6" date="01/25/2017" host="NESJO02" version="9.5.1"/>
</meta>

<id>A9E8D2ED7E0911E38C7A14109FD4194B</id>
<Documentation>Put documentation of the Test Case here.</Documentation>
<IsInProject>true</IsInProject>
<sig>ZWQ9NSZ0Y3Y9NSZsaXNhdj05LjUuMSAoOS41LjEuNikmbm9kZXM9MTk3Nzg3Njk4Mg==</sig>
<subprocess>false</subprocess>

<initState>
</initState>

<resultState>
</resultState>

<deletedProps>
</deletedProps>

    <Node log="" name="Read VSI file" next="List Operations from VSI" quiet="true" think="0" type="com.itko.lisa.test.FileNode" uid="104078D07E0A11E38C7A14109FD4194B" useFilters="true" version="1"> 


      <!-- Filters -->
      <Filter type="com.itko.lisa.xml.FilterXMLXPath">
        <valueToFilterKey>lisa.Read VSI file.rsp</valueToFilterKey>
<prop>temp</prop>
<xpathq>count(/serviceImage/st/t[1]/sp/t[*]/rq/@op)</xpathq>
      </Filter>

<Loc>{{LISA_RELATIVE_PROJ_ROOT}}/VirtualServices/Images/Java_demo.vsi</Loc>
<charset>DEFAULT</charset>
<PropKey>fl_vsifile</PropKey>
<onFail>abort</onFail>
    </Node>


    <Node log="" name="List Operations from VSI" next="end" quiet="false" think="0" type="com.itko.lisa.test.UserScriptNode" uid="811C8883E28411E6BE0FDE0620524153" useFilters="true" version="1"> 


      <!-- Assertions -->
<CheckResult assertTrue="true" name="Any Exception Then Fail" type="com.itko.lisa.dynexec.CheckInvocationEx">
<log>Assertion name: Any Exception Then Fail checks for: true is of type: Assert on Invocation Exception.</log>
<then>fail</then>
<valueToAssertKey/>
        <param>.*</param>
</CheckResult>

<onerror>abort</onerror>
<language>BeanShell</language>
<copyProps>TestExecProps</copyProps>
<script>import javax.xml.parsers.DocumentBuilder;&#xd;
import javax.xml.parsers.DocumentBuilderFactory;&#xd;
import javax.xml.parsers.ParserConfigurationException;&#xd;
&#xd;
import javax.xml.xpath.XPath;&#xd;
import javax.xml.xpath.XPathFactory;&#xd;
import javax.xml.xpath.XPathExpression;&#xd;
import javax.xml.xpath.XPathConstants;&#xd;
&#xd;
import org.w3c.dom.Document;&#xd;
import java.io.IOException;&#xd;
import org.xml.sax.SAXException;&#xd;
&#xd;
String operationList = "";&#xd;
DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();&#xd;
DocumentBuilder builder = null;&#xd;
builder = builderFactory.newDocumentBuilder();&#xd;
&#xd;
String vsifile = testExec.getStateValue("fl_vsifile");&#xd;
Document vsiDocument = builder.parse( new ByteArrayInputStream( vsifile.getBytes( ) ) );&#xd;
&#xd;
public getValue(xpath, searchString, document) {&#xd;
    XPathExpression expr = xpath.compile(searchString);&#xd;
    xpathResult = (String) expr.evaluate(document, XPathConstants.STRING);&#xd;
    return xpathResult;&#xd;
}&#xd;
&#xd;
XPathFactory xpathFactory = XPathFactory.newInstance();&#xd;
XPath xpath = xpathFactory.newXPath();&#xd;
&#xd;
// XPath count the number of blocks from VSI&#xd;
document = vsiDocument;&#xd;
searchString = "count(/serviceImage/st/t)";&#xd;
int requestBlocks = Integer.parseInt( getValue( xpath, searchString, document) );&#xd;
&#xd;
for ( currentRequestBlock = 1; currentRequestBlock &lt;= requestBlocks; currentRequestBlock++) {&#xd;
    // Xpath Count the # Operations in this Block&#xd;
    searchString = "count(/serviceImage/st/t[" + currentRequestBlock + "]/sp/t[*]/rq/@op)";&#xd;
    requestCount = Integer.parseInt( getValue(xpath, searchString, document));&#xd;
&#xd;
    // iterate over the Operations and extract their names&#xd;
    for ( currentRequestNumber = 1; currentRequestNumber &lt;= requestCount; currentRequestNumber++ ) {&#xd;
        searchString = "/serviceImage/st/t[" + currentRequestBlock + "]/sp/t[" + currentRequestNumber + "]/rq/@op";&#xd;
        operationName = getValue(xpath, searchString, document);&#xd;
&#xd;
        // Keep duplicates off the list -- remove this code to print duplicates&#xd;
        if ( operationList.contains( operationName ) ) {&#xd;
             _logger.info( " Operation Name: {} Already exists in the List", operationName );&#xd;
        } else { &#xd;
            operationList += operationName + "\r\n";&#xd;
            _logger.info( " Op = " + operationName );&#xd;
        } // end if&#xd;
    } // end for&#xd;
} // end for&#xd;
&#xd;
// Echo the list of operations into the LASTRESPONSE&#xd;
return operationList;</script>
    </Node>


    <Node log="" name="end" next="fail" quiet="true" think="0h" type="com.itko.lisa.test.NormalEnd" uid="A9E8D2F37E0911E38C7A14109FD4194B" useFilters="true" version="1"> 

    </Node>


    <Node log="" name="fail" next="abort" quiet="true" think="0h" type="com.itko.lisa.test.Abend" uid="A9E8D2F17E0911E38C7A14109FD4194B" useFilters="true" version="1"> 

    </Node>


    <Node log="" name="abort" next="" quiet="true" think="0h" type="com.itko.lisa.test.AbortStep" uid="A9E8D2EF7E0911E38C7A14109FD4194B" useFilters="true" version="1"> 

    </Node>


</TestCase>